package org.apithefire.util;

/** @deprecated unused. @see Objects */
@Deprecated
public class ToStringBuilder {

	private static class State {
		public void initialize(ToStringBuilder toString, Object object) {
			throw new IllegalStateException(getClass().toString());
		}
		public ToStringBuilder value(ToStringBuilder toString, String value, boolean quote) {
			throw new IllegalStateException(getClass().toString());
		}
		public ToStringBuilder property(
				ToStringBuilder toString, String name, String value, boolean quote) {
			throw new IllegalStateException(getClass().toString());
		}
		public String toString(ToStringBuilder toString) {
			throw new IllegalStateException(getClass().toString());
		}
	}
	
	private static class InitialState extends State{
		@Override
		public void initialize(ToStringBuilder toString, Object object) {
			StringBuilder stringBuilder = toString.stringBuilder;
			
			stringBuilder.append(object.getClass().getSimpleName());
			stringBuilder.append('[');
		}
		@Override
		public ToStringBuilder value(ToStringBuilder toString, String value, boolean quote) {
			StringBuilder stringBuilder = toString.stringBuilder;
			
			if (quote) {
				stringBuilder.append('"');
			}
			escapeAppend(stringBuilder, value);
			
			if (quote) {
				stringBuilder.append('"');
			}
			toString.state = PENDING_BUILD;
			return toString;
		}
		@Override
		public ToStringBuilder property(
				ToStringBuilder toString, String name, String value, boolean quote) {
			StringBuilder stringBuilder = toString.stringBuilder;
			
			stringBuilder.append(name);
			stringBuilder.append("=");
			
			if (quote) {
				stringBuilder.append('"');
			}
			escapeAppend(stringBuilder, value);
			
			if (quote) {
				stringBuilder.append('"');
			}
			toString.state = DIRTIED;
			return toString;
		}
		@Override
		public String toString(ToStringBuilder toString) {
			StringBuilder stringBuilder = toString.stringBuilder;
			
			stringBuilder.append("hashCode=");
			stringBuilder.append(toString.object.hashCode());
			stringBuilder.append(']');
			
			String string = stringBuilder.toString();

			toString.state = CLOSED;
			return string;
		}
	};
	
	private static class DirtiedState extends State {
		@Override
		public ToStringBuilder property(
				ToStringBuilder toString, String name, String value, boolean quote) {
			StringBuilder stringBuilder = toString.stringBuilder;
			
			stringBuilder.append(',');
			stringBuilder.append(name);
			stringBuilder.append("=");
			
			if (quote) {
				stringBuilder.append('"');
			}
			escapeAppend(stringBuilder, value);
			
			if (quote) {
				stringBuilder.append('"');
			}
			toString.state = DIRTIED;
			return toString;
		}
		@Override
		public String toString(ToStringBuilder toString) {
			StringBuilder stringBuilder = toString.stringBuilder;
		
			stringBuilder.append(']');
			
			String string = stringBuilder.toString();

			toString.state = CLOSED;
			return string;
		}
	};
	
	private static class PendingBuildState extends State {
		@Override
		public String toString(ToStringBuilder toString) {
			StringBuilder stringBuilder = toString.stringBuilder;
		
			stringBuilder.append(']');
			
			String string = stringBuilder.toString();

			toString.state = CLOSED;
			return string;
		}
	};

	private static final State INITIAL = new InitialState();
	private static final State DIRTIED = new DirtiedState();
	private static final State PENDING_BUILD = new PendingBuildState();
	private static final State CLOSED = new State();
	
	private State state = INITIAL;
	private Object object;
	private StringBuilder stringBuilder;
	
	protected ToStringBuilder(Object object) {
		this.object = Objects.nonNull(object);
		this.stringBuilder = new StringBuilder();
		state.initialize(this, object);
	}
	
	private static void escapeAppend(
			StringBuilder stringBuilder, String string) {
		int length = string.length();
		
		for (int i = 0; i < length; ++i) {
			char ch = string.charAt(i);
			
			if ('"' == ch) {
				stringBuilder.append("\\\"");
			} else if ('\n' == ch) {
				stringBuilder.append("\\n");
			} else if ('\r' == ch) {
				stringBuilder.append("\\r");
			} else {
				stringBuilder.append(ch);
			}
		}
	}
	
	public ToStringBuilder value(boolean value) {
		return state.value(this, Boolean.toString(value), false);
	}
	
	public ToStringBuilder value(char value) {
		return state.value(this, Character.toString(value), false);
	}
	
	public ToStringBuilder value(short value) {
		return state.value(this, Short.toString(value), false);
	}
	
	public ToStringBuilder value(int value) {
		return state.value(this, Integer.toString(value), false);
	}
	
	public ToStringBuilder value(long value) {
		return state.value(this, Long.toString(value), false);
	}
	
	public ToStringBuilder value(float value) {
		return state.value(this, Float.toString(value), false);
	}
	
	public ToStringBuilder value(double value) {
		return state.value(this, Double.toString(value), false);
	}
	
	public ToStringBuilder value(Object value) {
		if (value == null) {
			return state.value(this, null, false);
		}
		if (value instanceof String) {
			return state.value(this, (String) value, true);
		}
		return state.value(this, value.toString(), false);
	}
	
	public ToStringBuilder value(String value) {
		return state.value(this, value, true);
	}
	
	public ToStringBuilder property(String name, boolean value) {
		return state.property(this, Objects.nonNull(name),
				Boolean.toString(value), false);
	}
	
	public ToStringBuilder property(String name, char value) {
		return state.property(this, Objects.nonNull(name),
				Character.toString(value), false);
	}
	
	public ToStringBuilder property(String name, short value) {
		return state.property(this, Objects.nonNull(name),
				Short.toString(value), false);
	}
	
	public ToStringBuilder property(String name, int value) {
		return state.property(this, Objects.nonNull(name),
				Integer.toString(value), false);
	}
	
	public ToStringBuilder property(String name, long value) {
		return state.property(this, Objects.nonNull(name),
				Long.toString(value), false);
	}
	
	public ToStringBuilder property(String name, float value) {
		return state.property(this, Objects.nonNull(name),
				Float.toString(value), false);
	}
	
	public ToStringBuilder property(String name, double value) {
		return state.property(this, Objects.nonNull(name),
				Double.toString(value), false);
	}
	
	public ToStringBuilder property(String name, Object value) {
		if (value == null) {
			return state.property(this, Objects.nonNull(name), null, false);
		}
		if (value instanceof String) {
			return state.property(this, Objects.nonNull(name),
					(String) value, true);
		}
		return state.property(this, Objects.nonNull(name),
				value.toString(), false);
	}
	
	public ToStringBuilder property(String name, String value) {
		return state.property(this, Objects.nonNull(name), value, true);
	}
	
	@Override
	public String toString() {
		return state.toString(this);
	}
	
}
